<?php

$params = require __DIR__ . '/params.php';
$db = require __DIR__ . '/db.php';

$config = [
    'id' => 'basic',

    'basePath' => dirname(__DIR__),
    'bootstrap' => ['log'],
    'aliases' => [
        '@bower' => '@vendor/bower-asset',
        '@npm'   => '@vendor/npm-asset',
    ],
    'components' => [
        'request' => [
            'parsers' => [
                    'application/json' => 'yii\web\JsonParser',
            ],
            'enableCsrfValidation' => false,
            // !!! insert a secret key in the following (if it is empty) - this is required by cookie validation
            'cookieValidationKey' => 'P9HfAQYdIti-m1CVE6LXzfZd6p6adKk7',
            'baseUrl'=> '/api/',
            
        ],
        'response' => [                 
            //'format' => yii\web\Response::FORMAT_JSON, 
            'charset' => 'UTF-8',               
        ],
        'cache' => [
            'class' => 'yii\caching\FileCache',
        ],
        'user' => [
            'identityClass' => 'app\models\User',
            'enableAutoLogin' => true,
        ],
        'errorHandler' => [
            'errorAction' => 'site/error',
        ],
        'mailer' => [
            'class' => 'yii\swiftmailer\Mailer',
            // send all mails to a file by default. You have to set
            // 'useFileTransport' to false and configure a transport
            // for the mailer to send real emails.
            'useFileTransport' => true,
        ],
        'log' => [
            'traceLevel' => YII_DEBUG ? 3 : 0,
            'targets' => [
                [
                    'class' => 'yii\log\FileTarget',
                    'levels' => ['error', 'warning'],
                ],
            ],
        ],
        'doctrine'  => [
            'class'    => Infinitiweb\YiiDoctrine\Component::class,
            'dbal' => [
               //'url' => 'pdo_mysql://Denis:123@localhost/promsystem'
               'driver'   => 'pdo_mysql',
                'user'     => 'Denis',
                'password' => '123',
                'dbname'   => 'promsystem',
            ],
            'myparams' =>[
               //'url' => 'pdo_mysql://Denis:123@localhost/promsystem'
               'driver'   => 'pdo_mysql',
                'user'     => 'Denis',
                'password' => '123',
                'dbname'   => 'promsystem',
            ],
            'entityPath' => [
                '@app/entity'
            ]
        ],
        
        'db' => $db,
        
        'urlManager' => [
            'enablePrettyUrl' => true,
            'showScriptName' => false,
            'rules' => [
                    '<controller>/<action>' => '<controller>/<action>'
            ],
        ],

        

        
    ],
    'modules' => [
        'api' => [
            'class' => 'app\modules\Module',
        ],
    ],
    'params' => $params,
];

if (YII_ENV_DEV) {
    // configuration adjustments for 'dev' environment
    $config['bootstrap'][] = 'debug';
    $config['modules']['debug'] = [
        'class' => 'yii\debug\Module',
        // uncomment the following to add your IP if you are not connecting from localhost.
        //'allowedIPs' => ['127.0.0.1', '::1'],
    ];

    $config['bootstrap'][] = 'gii';
    $config['modules']['gii'] = [
        'class' => 'yii\gii\Module',
        // uncomment the following to add your IP if you are not connecting from localhost.
        //'allowedIPs' => ['127.0.0.1', '::1'],
    ];
}

return $config;
