<?php

/**
 * @Entity @Table(name="projects_locotech")
 */

class Project extends BaseDBO
{
    /**
     * One project has many tasks. This is the inverse side.
     * @OneToMany(targetEntity="Task", mappedBy="project")
     */
    private $tasks;
    /**
     * @ManyToOne(targetEntity="ProjectType", inversedBy="project")
     * @JoinColumn(name="action", referencedColumnName="id")
     */
    private $projectTypes;

    public function __construct() {
        $this->projectTypes = new \Doctrine\Common\Collections\ArrayCollection();
        $this->tasks = new \Doctrine\Common\Collections\ArrayCollection();
    }

    public function getTasks(): Task
    {
        return $this->tasks;
    }

    public function addTask(Task $task)
    {
        $this->tasks[] = $task;
    }

    public function getActions(): ProjectType
    {
        return $this->actions;
    }

    public function setActions(ProjectType $actions)
    {
        $this->actions = $actions;
    }
    
    /**
     * @Id @Column(type="integer") @GeneratedValue
    */
    private $id;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $action;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $company;

    /**
     * @var boolean
     *
     * @Column(type="smallint")
     */
    private $status;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $locoType;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $locoNumber;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $depo;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $depoService;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    private $created;

//    /**
//     * @var string
//     *
//     * @Column(type="string")
//     */
//    private $tasks;

    public function getId()
    {
        return $this->id;
    }

    public function getAction()
    {
        return $this->action;
    }

    public function setAction(int $action)
    {
        $this->action = $action;

        return $this;
    }

    public function getCompany()
    {
        return $this->company;
    }

    public function setCompany(int $company)
    {
        $this->company = $company;

        return $this;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setStatus(bool $status)
    {
        $this->status = $status;

        return $this;
    }

    public function getLocoType()
    {
        return $this->locoType;
    }

    public function setLocoType(string $locoType)
    {
        $this->locoType = $locoType;

        return $this;
    }

    public function getLocoNumber()
    {
        return $this->locoNumber;
    }

    public function setLocoNumber(int $locoNumber)
    {
        $this->locoNumber = $locoNumber;

        return $this;
    }

    public function getDepo()
    {
        return $this->depo;
    }

    public function setDepo(string $depo)
    {
        $this->depo = $depo;

        return $this;
    }

    public function getDepoService()
    {
        return $this->depoService;
    }

    public function setDepoService(string $depoService)
    {
        $this->depoService = $depoService;

        return $this;
    }

    public function getCreated()
    {
        return $this->created;
    }

    public function setCreated(\DateTimeInterface $created)
    {
        $this->created = $created;

        return $this;
    }
}

