<?php
/**
 * @Entity @Table(name="projecttypes")
 */

class ProjectType extends BaseDBO
{
    /**
     * One product has many features. This is the inverse side.
     * @OneToMany(targetEntity="Project", mappedBy="projecttypes")
     */
    private $projects;


    /**
     * Many ProjectType have Many Tasktypes.
     * @ManyToMany(targetEntity="Tasktype",inversedBy="projecttypes")
     * @JoinTable(name="projecttypes_tasktypes")
     */
    private $tasktypes;

    public function __construct() {
        $this->tasktypes = new \Doctrine\Common\Collections\ArrayCollection();
        $this->projects = new \Doctrine\Common\Collections\ArrayCollection();
    }


    /**  @Id @Column(type="integer") @GeneratedValue */
    private $id;

    /**
     * @Column(type="string")
     */
    private $name;

    /**
     * @Column(type="string")
     */
    private $company;

    public function getTasktypes()
    {
        return $this->tasktypes;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName(string $name)
    {
        $this->name = $name;

        return $this;
    }

    public function getCompany()
    {
        return $this->company;
    }

    public function setCompany(int $company)
    {
        $this->company = $company;

        return $this;
    }
//
//    public function addProject(Project $projectslocotech): self
//    {
//        if (!$this->projects->contains($projectslocotech)) {
//            $this->projects[] = $projectslocotech;
//            $projectslocotech->setActions($this);
//        }
//
//        return $this;
//    }
//
//    public function removeProject(Project $projectslocotech): self
//    {
//        if ($this->projects->contains($projectslocotech)) {
//            $this->projects->removeElement($projectslocotech);
//            // set the owning side to null (unless already changed)
//            if ($projectslocotech->getActions() === $this) {
//                $projectslocotech->setActions(null);
//            }
//        }
//
//        return $this;
//    }


}

