<?php
/**
 * @Entity @Table(name="project_types")
 */

class Projecttypes
{
    
    /**
    * Many Jobtypes have Many Tasktypes.
    * @ManyToMany(targetEntity="Tasktype",inversedBy="Projecttypes")
    * @JoinTable(name="projectstypes_tasktypes",)
    */     
     
    private $tasktypes_rel;
    
    /**
     * @ORM\OneToMany(targetEntity="App\Entity\ProjectsLocotech", mappedBy="project_types")
     */
    
    private $projectslocotech;

    public function __construct()
    {
        $this->projectslocotech = new ArrayCollection();
        $this->tasktypes_rel = new ArrayCollection();
    }

    /**
     * @return Collection|ProjectsLocotech[]
     */
    public function getProjectsLocotech()
    {
        return $this->projectslocotech;
    }
    
    /**
     * @var integer
     *
     ** @Id @Column(type="integer") @GeneratedValue */
    private $id;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $name;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $inputKeyword;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $company;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $tasktypes;

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName(string $name)
    {
        $this->name = $name;

        return $this;
    }

    public function getInputKeyword()
    {
        return $this->inputKeyword;
    }

    public function setInputKeyword(string $inputKeyword)
    {
        $this->inputKeyword = $inputKeyword;

        return $this;
    }

    public function getCompany()
    {
        return $this->company;
    }

    public function setCompany(int $company)
    {
        $this->company = $company;

        return $this;
    }

    public function getTasktypes()
    {
        return $this->tasktypes;
    }

    public function setTasktypes(string $tasktypes)
    {
        $this->tasktypes = $tasktypes;

        return $this;
    }
    
    public function getTasktypesRel()
    {

        return $this->tasktypes_rel;
    }

    public function addProjectslocotech(ProjectsLocotech $projectslocotech): self
    {
        if (!$this->projectslocotech->contains($projectslocotech)) {
            $this->projectslocotech[] = $projectslocotech;
            $projectslocotech->setActions($this);
        }

        return $this;
    }

    public function removeProjectslocotech(ProjectsLocotech $projectslocotech): self
    {
        if ($this->projectslocotech->contains($projectslocotech)) {
            $this->projectslocotech->removeElement($projectslocotech);
            // set the owning side to null (unless already changed)
            if ($projectslocotech->getActions() === $this) {
                $projectslocotech->setActions(null);
            }
        }

        return $this;
    }

    public function addTasktypesProjecttypes(Tasktype $taskType)
    {
        return $this->tasktypes_rel[] = $taskType;
    }

}
