<?php
 /**
 * @Entity @Table(name="tasktypes")
 */
class Tasktype extends BaseDBO
{

    /** @Id @Column(type="integer") @GeneratedValue */
    protected $id;
    /**
    * Many Jobtypes have Many Tasktypes.
    * @ManyToMany(targetEntity="Jobtype",mappedBy="tasktypes")
    */
    private $jobtypes;
    /**
     * Many ProjectType have Many Tasktypes.
     * @ManyToMany(targetEntity="ProjectType",inversedBy="tasktypes")
     * @JoinTable(name="projecttypes_tasktypes")
     */
    private $projecttypes;
    
    /**
    * Many Jobtypes have Many Tasktypes.
    * @ManyToMany(targetEntity="Projecttypes",inversedBy="Tasktype")
    * @JoinTable(name="projectstypes_tasktypes",)
    */     
     
    private $projecttypes_rel;
    
    public function __construct() {
    
        $this->jobtypes = new \Doctrine\Common\Collections\ArrayCollection();
        $this->projecttypes = new \Doctrine\Common\Collections\ArrayCollection();
    }

    public function GetProjectTypes()
    {
        return $this->projecttypes;
    }


    /**
     * @Column(type="smallint")
     */
    public $action;

    /**
     * @Column(type="string")
     */
    public $creator_id;

    /**
     * @Column(type="string")
     */
    public $name;

    /**
     * @Column(type="string")
     */
    public $description;

    /**
     * @Column(type="smallint")
     */
    public $company;

    /**
     * @Column(type="string")
     */
    public $main_task;

    /**
     * @Column(type="string")
     */
    public $subtasks;

    /**
     * @Column(type="smallint")
     */
    public $confirmtype;

    /**
     * @Column(type="smallint")
     */
    public $time_to_complete_minutes;

    /**
     * @Column(type="string")
     */
    public $object_name;

    /**
     * @Column(type="string")
     */
    public $control_map;


//    public function getAction()
//    {
//        return $this->action;
//    }
//
//    public function setAction(int $action)
//    {
//        $this->action = $action;
//
//        return $this;
//    }
//
//    public function getCreatorId()
//    {
//        return $this->creator_id;
//    }
//
//    public function setCreatorId(string $creator_id)
//    {
//        $this->creator_id = $creator_id;
//
//        return $this;
//    }
//
//    public function getName()
//    {
//        return $this->name;
//    }
//
//    public function setName(string $name)
//    {
//        $this->name = $name;
//
//        return $this;
//    }

//    public function getDescription()
//    {
//        return $this->description;
//    }

//    public function setDescription(string $description)
//    {
//        $this->description = $description;
//
//        return $this;
//    }
//
//    public function getCompany()
//    {
//        return $this->company;
//    }
//
//    public function setCompany(int $company)
//    {
//        $this->company = $company;
//
//        return $this;
//    }
//
//    public function getMainTask()
//    {
//        return $this->main_task;
//    }
//
//    public function setMainTask(string $main_task)
//    {
//        $this->main_task = $main_task;
//
//        return $this;
//    }
//
//    public function getSubtasks()
//    {
//        return $this->subtasks;
//    }
//
//    public function setSubtasks(string $subtasks)
//    {
//        $this->subtasks = $subtasks;
//
//        return $this;
//    }
//
//    public function getConfirmtype()
//    {
//        return $this->confirmtype;
//    }
//
//    public function setConfirmtype(bool $confirmtype)
//    {
//        $this->confirmtype = $confirmtype;
//
//        return $this;
//    }
//
//    public function getTimeToCompleteMinutes()
//    {
//        return $this->time_to_complete_minutes;
//    }
//
//    public function setTimeToCompleteMinutes(bool $time_to_complete_minutes)
//    {
//        $this->time_to_complete_minutes = $time_to_complete_minutes;
//
//        return $this;
//    }
//
//    public function getObjectName()
//    {
//        return $this->object_name;
//    }
//
//    public function setObjectName(string $object_name)
//    {
//        $this->object_name = $object_name;
//
//        return $this;
//    }
//
//    public function getControlMap()
//    {
//        return $this->control_map;
//    }


//
//    public function setControlMap(string $control_map)
//    {
//        global $entityManager;
//        $this->control_map = $control_map;
//        //echo 'name '.$this->name;
//        //var_dump(gettype($entityManager));
//        $entityManager->persist($this);
//        $entityManager->flush();
//        return $this;
//    }

    public function getJobtypes()
    {
        return $this->jobtypes;
    }
    
    public function getProjecttypesRel()
    {

        return $this->projecttypes_rel;
    }
    
    public function addTasktypesProjecttypes(Projecttypes $projecttypes)
    {
        return $this->projecttypes_rel[] = $projecttypes;
    }

}

