<?php

namespace app\models;

use Yii;
use yii\base\Model;
use app\models\entity\ProjectsLocotech;
use app\models\entity\Tasks;



class EmployeesModel extends MainModel
{
    
    public $errors = [];
    
    /*
     * Запрос (от SMoPP в ЕИПП) Получить список исполнителей по должности
     */
    
    
    public function getWorkers($params = [])
    {
        if ( empty ($params)) {
            $this->errors['Workers'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathListofperformers'];
        return $this->curlRequest( $url,$params );
    }
    
    /*
     * Запрос (от SMoPP в ЕИПП) Получить статус сотрудника
     */
    
    public function getEmployeeStatus( $params = [])
    {
        if ( empty ($params)) {
            $this->errors['getEmployeeStatus'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathStatusOfEmployee'];
        $result = $this->curlRequest( $url,$params );
        
        return $result;
    }
    
    /*
     * Запрос (от SMoPP в ЕИПП) Получить график по исполнителю на дату
     */
    
    
    
    public function getWorkerTimetable( $params = [] )
    {
        if ( empty ($params)) {
            $this->errors['WorkerTimetable'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathScheduleByPerformer'];
        
        
        return $this->curlRequest($url,$params);
    }
    

    
    /* 
     * Возвращает справочник должностей 
     * $params: параметры запроса
     * return: false/результат запроса к методу
     */
    
    public function getPositionList()
    {

        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathGetPositionList'];
        $params = [];
        return $this->curlRequest($url,$params);
    }
    
    
    
}

