<?php

namespace app\models;

use Yii;
use yii\base\Model;
use app\models\entity\ProjectsLocotech;
use app\models\entity\Tasks;
use app\models\entity\Tasknotes;



class LocomotiveModel extends MainModel
{

    public $project_id;
    /*
        Запрос (от SMoPP в ЕИПП)  Записать факт проведения приемки
    */
    
    public function addCompletedWork( $params = [] )
    {
        if ( empty ($params)) {
            $this->errors['getCompletedWork'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathExecuteReceiving'];
        
        return $this->curlRequest( $url,$params );
    }
    
    /*
    
        Запрос (от SMoPP в ЕИПП) Получить список секций на дату – ПолучитьПланНаДату
    
    */
    
    public function getSectionList( $params = [] )
    {
        if ( empty ($params)) {
            $this->errors['getSectionList'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathListOfSections'];
                
        return $this->curlRequest( $url,$params );
    }
    
    /*
        Запрос (от SMoPP в ЕИПП)  Получить список актуальных замечаний по секции
    
    */
    
    public function getSectionRemarks( $params = [], $record = false )
    {
        if ( empty ($params)) {
            $this->errors['getSectionRemarks'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathListCurrentComments'];
                
        if ( $record ) {
            
            $result = json_decode($this->curlRequest( $url,$params ));
            $result = json_decode($result->rows[0]->result);
            
            if( is_array($result) and ( count($result) > 0 ) ) {
                foreach($result as $note) {
                    $tasknotesEntity = new Tasknotes();
                    $tasknotesEntity->uuid = $note->remarkID;
                    $tasknotesEntity->project_id = $this->project_id;
                    $tasknotesEntity->save();
                    $this->errors['getSectionRemarks'] = $tasknotesEntity->errors;
                }
            }
            if ( null != $this->errors['getSectionRemarks']) {
                return false;
            }
            return true;
        }
        
        return $this->curlRequest( $url,$params );
    }


    public function getSectionInfo( $params = [] )
    {
        if ( empty ($params)) {
            $this->errors['getSectionInfo'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathGetSectionInfo'];

        return $this->curlRequest( $url,$params );
    }

    /*
    
        Запрос (от SMoPP в ЕИПП)   Создать замечание секции по ДК в АСУ СГ
    
    */
    
    public function addRemark( $params = [] )
    {
        if ( empty ($params)) {
            $this->errors['getSectionRemarks'] = "";
            return false;
        }
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathCommentSection'];
        
        return $this->curlRequest( $url,$params );
    }
    
    /* 
    * Возвращает список СЛД
    * $params: параметры запроса
    * return: false/результат запроса к методу
    */
    
        public function getSldList ( $params = [] )
    {

        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathGetSldList'];
        
        
        return $this->curlRequest($url,$params);
    }
    
    /* 
    * Возвращает список СЛД
    * $params: параметры запроса
    * return: false/результат запроса к методу
    */
    
    public function getRepairSites ( $params = [] )
    {

        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathGetRepairSites'];
        
        
        return $this->curlRequest($url,$params);
    }
    
    public function getSourcesOfComents( $params = [] )
    {
        $url = Yii::$app->params['api']['domain'] . Yii::$app->params['api']['pathGetSourcesOfComents'];
        return $this->curlRequest($url,$params);
    }
    

    
}
