<?php

namespace app\models\entity;

/**
 * This is the model class for table "accounts_jobtypes".
 *
 * @property int $account_id [int(10) unsigned]
 * @property int $jobtype_id [int(10) unsigned]
 * @property int $priority [smallint(5) unsigned]
 *
 * @property Accounts $accounts
 * @property Jobtypes $jobtypes
 */
class AccountsJobtypes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'accounts_jobtypes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['accounts_id', 'jobtypes_id'], 'required'],
            [['accounts_id', 'jobtypes_id'], 'integer'],
            [['accounts_id'], 'exist', 'skipOnError' => true, 'targetClass' => Accounts::className(), 'targetAttribute' => ['accounts_id' => 'id']],
            [['jobtypes_id'], 'exist', 'skipOnError' => true, 'targetClass' => Jobtypes::className(), 'targetAttribute' => ['jobtypes_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'accounts_id' => 'Accounts ID',
            'jobtypes_id' => 'Jobtypes ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAccounts()
    {
        return $this->hasOne(Accounts::className(), ['id' => 'accounts_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJobtypes()
    {
        return $this->hasOne(Jobtypes::className(), ['id' => 'jobtypes_id']);
    }
}
