<?php

namespace app\models\entity;

/**
 * This is the model class for table "asusg_task".
 *
 * @property int $id
 * @property int $loco_serie_id [int(10) unsigned]
 * @property int $repair_type [int(10) unsigned]
 * @property int $loco_number [int(10) unsigned]
 * @property int $section_a [int(10) unsigned]
 * @property int $section_b [int(10) unsigned]
 * @property int $section_c [int(10) unsigned]
 * @property string $created [datetime]
 * @property string $started [datetime]
 * @property string $finished [datetime]
 * @property string $text [varchar(45)]
 * @property int $status [int(10) unsigned]
 * @property int $asusg_projecttype_id [int(10) unsigned]
 * @property int $order_a [int(11)]
 * @property int $order_b [int(11)]
 * @property int $order_c [int(11)]
 */
class AsusgProject extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_project';
    }

    public function getLocomotiveSeries()
    {
        return $this->hasOne(LocomotiveSeries::class, ['id' => 'loco_serie_id']);
    }

    public function getRepairtypes()
    {
        return $this->hasOne(Repairtypes::class, ['id' => 'repair_type']);
    }
}
