<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "asusg_task".
 *
 * @property int $id
 * @property int $template_id
 * @property string $created
 */
class AsusgProjectType extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'asusg_projecttype';
    }

    public function getLocomotiveseries()
    {
        return $this->hasOne(LocomotiveSeries::className(), ['id' => 'loco_serie_id']);
    }
    
    public function getJob2Project()
    {
        return $this->hasMany(AsusgJob2Project::className(), ['asusg_projecttype_id' => 'id'])->orderBy(['job_order' => SORT_ASC]);
    }
    public function getJob2Command()
    {
        return $this->hasMany(AsusgJob2Command::className(), ['asusg_projecttype_id' => 'id'])->orderBy(['job_order' => SORT_ASC]);
    }
}
