<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "tmc_cell".
 *
 * @property int $id
 * @property string $title
 * @property int $stack
 * @property int $number
 */
class Cell extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tmc_cell';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['number', 'stack'], 'integer'],
            [['title'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'title' => 'Title',
            'stack' => 'ID stack',
            'number' => 'Number of warehouse',
        ];
    }

    /** @return Stack|null */
    public function getStack()
    {
        return Stack::findOne($this->stack);
    }
}
