<?php
namespace app\models\entity;

use yii\db\ActiveRecord;

 /**
 * @property int $id [int(5)]
 * @property string $face_feature
 * @property int $id_account [int(5)]
 * @property int $date [timestamp]
 * @property string $token_device [varchar(255)]
 */

class FaceFeature extends ActiveRecord
{
    /**
     * @return string название таблицы, сопоставленной с этим ActiveRecord-классом.
     */
    public static function tableName()
    {
        return '{{face_feature}}';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            //[['id'], 'required'],
            [['id', 'id_account'], 'integer'],
            //[['face_feature'], 'text'],
            [['token_device'], 'string', 'max' => 255],
            [['id'], 'unique']
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'face_feature' => 'Face feature',
            'id_account' => 'Account ID',
            'date' => 'Date',
            'token_device' => 'Token Device'
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAccount()
    {
        return $this->hasOne(Accounts::className(), ['id' => 'id_account']);
    }

    public function getId()
    {
        return $this->id;
    }
}
