<?php

namespace app\models\entity;

use Yii;


/**
 * This is the model class for table "jobtypes".
 *
 * @property int $id
 * @property string $name
 * @property int $company
 * @property string $tasktypes
 *
 * @property AccountsJobtypes[] $accountsJobtypes
 * @property JobtypesTasktypes[] $jobtypesTasktypes
 */
class Jobtypes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'jobtypes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['id'], 'required'],
            [['id', 'company'], 'integer'],
            [['name', 'tasktypes'], 'string', 'max' => 255],
            [['id'], 'unique'],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Name',
            'company' => 'Company',
            'tasktypes' => 'Tasktypes',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getAccountsJobtypes()
    {
        return $this->hasMany(AccountsJobtypes::className(), ['jobtype_id' => 'id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJobtypesTasktypes()
    {
        return $this->hasMany(JobtypesTasktypes::className(), ['jobtype_id' => 'id']);
    }
    
    public function getTasktype()
    {
        return $this->hasMany(Tasktypes::className(), ['id' => 'tasktype_id'])
             ->via('jobtypesTasktypes');
    }
}
