<?php

namespace app\models\entity;

use Yii;

/**
 * This is the model class for table "jobtypes_tasktypes".
 *
 * @property int $jobtypes_id
 * @property int $tasktypes_id
 *
 * @property Jobtypes $jobtypes
 * @property Tasktypes $tasktypes
 */
class JobtypesTasktypes extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'jobtypes_tasktypes';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['jobtypes_id', 'tasktypes_id'], 'required'],
            [['jobtypes_id', 'tasktypes_id'], 'integer'],
            [['jobtypes_id'], 'exist', 'skipOnError' => true, 'targetClass' => Jobtypes::className(), 'targetAttribute' => ['jobtypes_id' => 'id']],
            [['tasktypes_id'], 'exist', 'skipOnError' => true, 'targetClass' => Tasktypes::className(), 'targetAttribute' => ['tasktypes_id' => 'id']],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'jobtypes_id' => 'Jobtypes ID',
            'tasktypes_id' => 'Tasktypes ID',
        ];
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getJobtypes()
    {
        return $this->hasOne(Jobtypes::className(), ['id' => 'jobtypes_id']);
    }

    /**
     * @return \yii\db\ActiveQuery
     */
    public function getTasktypes()
    {
        return $this->hasOne(Tasktypes::className(), ['id' => 'tasktypes_id']);
    }
}
