<?php

namespace app\models\entity;

use yii\db\ActiveRecord;

/**
 * This is the model class for table "locomotive_series".
 *
 * @property int $id
 * @property string $name
 * @property int $sections
 * @property int $wheelpairs [smallint(6)]
 */
class LocomotiveSeries extends ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'locomotive_series';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['name', 'sections'], 'required'],
            [['sections','wheelpairs'], 'integer'],
            [['name'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'name' => 'Серия локомотива',
            'sections' => 'Количество секций',
            'wheelpairs' => 'Количество клесных пар',
        ];
    }
}
