<?php
namespace app\models\entity;

use yii\db\ActiveRecord;

/**
 * This is the model class for table "tasktypes".
 *
 * @property int $id
 * @property int $action [smallint(10) unsigned]
 * @property string $creator_id [varchar(255)]
 * @property string $name [varchar(1000)]
 * @property string $description [varchar(255)]
 * @property int $company [smallint(6) unsigned]
 * @property string $main_task [bit(1)]
 * @property string $subtasks [varchar(255)]
 * @property bool $confirmtype [tinyint(4) unsigned]  tokentype: 0 = подтверждение кнопкой на экране, 1 = barcode обычный, 2 = QRcode обычный, 3 = наш barcode с типом объекта, 4 = наш QRcode с типом объекта
 * @property bool $time_to_complete_minutes [tinyint(4) unsigned zerofill]
 * @property string $object_name [varchar(255)]  название счетчика или предмета, к которому относится действие
 * @property string $control_map [varchar(255)]
 * @property string $letter [char(1)]
 * @property int $scenario_id [int(11)]
 *
 * @property Tasks[] $tasks
 */
class Tasktypes extends ActiveRecord
{
    
    /**
     * @return string название таблицы, сопоставленной с этим ActiveRecord-классом.
     */
    public static function tableName()
    {
        return '{{tasktypes}}';
    }

    public function getTasks()
    {
        $this->hasMany(Tasks::class, ['id' => 'type']);
    }
}
