<?php

namespace app\models\entity;

/**
 * This is the model class for table "tools_devices".
 *
 * @property int $id
 * @property string $title
 * @property string $ip
 * @property string $mac
 * @property int $tmc_type
 * @property string $receipt_date
 * @property string $write_off_date
 * @property string $inventory_num
 * @property string $desc
 * @property int $status
 * @property int $company
 * @property int $storage
 * @property int $employee
 */
class Tmc extends \yii\db\ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'tools_devices';
    }

    /**
     * {@inheritdoc}
     */
    public function rules()
    {
        return [
            [['tmc_type', 'status', 'company', 'storage'], 'integer'],
            [['title', 'ip', 'mac', 'receipt_date', 'write_off_date', 'inventory_num', 'desc'], 'string', 'max' => 255],
        ];
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'title' => 'Title',
            'ip' => 'IP',
            'mac' => 'MAC',
            'tmc_type' => 'Type of tmc',
            'receipt_date' => 'Date of receipt',
            'write_off_date' => 'Date of write-off',
            'inventory_num' => 'Inventory number',
            'desc' => 'Description',
            'status' => 'ID status',
            'company' => 'ID company',
            'storage' => 'ID storage',
        ];
    }
}
