<?php /** Created by Anton on 11.02.2020. */

namespace app\models\entity\ar;

use yii\db\ActiveRecord;

/**
 * This is the model class for table "ar_media".
 *
 * @property int $id
 * @property int $stage_id [int(10)]
 * @property string $color [varchar(255)]
 * @property string $name_cursor [varchar(255)]
 * @property float $size_x [float]
 * @property float $size_y [float]
 * @property float $size_z [float]
 * @property float $pos_x [float]
 * @property float $pos_y [float]
 * @property float $pos_z [float]
 * @property float $rotation_x [float]
 * @property float $rotation_y [float]
 * @property float $rotation_z [float]
 * @property float $rotation_w [float]
 * @property int $message [text]
 */
class Media extends ActiveRecord
{
    /**
     * {@inheritdoc}
     */
    public static function tableName()
    {
        return 'ar_media';
    }

    /**
     * {@inheritdoc}
     */
    public function attributeLabels()
    {
        return [
            'id' => 'ID',
            'stage_id' => 'ID этапа',
            'color' => 'color',
            'name_cursor' => 'name_cursor',
            'size_x' => 'Размер X',
            'size_y' => 'Размер Y',
            'size_z' => 'Размер Z',
            'pos_x' => 'Координата X',
            'pos_y' => 'Координата Y',
            'pos_z' => 'Координата Z',
            'rotation_x' => 'Угол X',
            'rotation_y' => 'Угол Y',
            'rotation_z' => 'Угол Z',
            'rotation_w' => 'Поворот',
            'message' => 'Сообщение'
        ];
    }

    public function fillFromArray($params)
    {
        foreach ($params as $key => $fieldName) {
            $this->$key = $params[$key];
        }
    }

    public function asArray()
    {
        $media = [];
        foreach ($this->fields() as $fieldName) {
            $media[$fieldName] = $this->$fieldName;
        }

        return $media;
    }
}
