<?php

namespace app\models;

use Yii;
use yii\base\Model;
use app\models\entity\CheckpointTypes;
use app\models\entity\CheckpointTypeHierarchy;

/*

add_cb2cp: BEGIN
	declare checkbox_id integer;
    declare tmp integer;

	if checkbox is null then leave add_cb2cp; end if;

// 1 получение ид чекпоинта

    select id into checkbox_id
		from checkpoint_types
		where name = checkbox
			and class = 'CheckBox';
			
// 2 проверка на существование чекпоинта

    if checkbox_id is null then
		insert into checkpoint_types
			(name, class)
            values
            (checkbox, 'CheckBox');
        select id into checkbox_id
			from checkpoint_types
            where name = checkbox
				and class = 'CheckBox';
    end if;
    
// 3 проверка иерархии

	select cp_type into tmp
		from checkpoint_type_hierarchy
        where parent_cp_type = checkpoint_id
			and cp_type = checkbox_id;
			
	if tmp is null then
		insert into checkpoint_type_hierarchy
			(parent_cp_type, cp_type)
			values
			(checkpoint_id, checkbox_id);
	end if;
END
*/

class AsusgAddCheckboxToCheckpointModel extends Model
{
    private $tmp;
    private $cp_type;
    private $checkbox;
    private $checkbox_id;
    private $checkpoint_id;
    
    public function execute($checkpoint_id, $checkbox) 
    {
        $this->checkpoint_id = $checkpoint_id;
        $this->checkbox      = $checkbox;
        
        if ( null == $this->checkbox ){
            return false;
        }
        // 1 получение ид чекпоинта
        if(!$this->GetCheckpoint()) {
            return false;
        }
        // 2 проверка на существование чекпоинта
        //if(!$this->CheckIssetCheckpoint()) {
        //    return false;
        //}
        // 3 проверка иерархии
        if(!$this->CheckHierarchy()) {
            return false;
        }
        return true;
    }
    
    private function GetCheckpoint(){
    
        $checkpointTypesEntity = CheckpointTypes::findOne(['name' => $this->checkbox, 'class' => 'CheckBox']);
        $this->checkpoint_id = $checkpointTypesEntity->id;
        if ( null == $this->checkpoint_id) {
            if(!$this->CheckIssetCheckpoint()) {
                return false;
            }
        } 
        return true;
    }
    
    private function CheckIssetCheckpoint(){
        $CheckpointTypesEntity = new CheckpointTypes();
        $CheckpointTypesEntity->name  = $this->checkbox;
        $CheckpointTypesEntity->class = 'CheckBox';
        $CheckpointTypesEntity->save();
        $this->checkpoint_id = $CheckpointTypesEntity->id;
        if ( null == $this->checkpoint_id) {
            return false;
        } 
        return true;   
    }
    
    private function CheckHierarchy() {
    
        $checkpointTypeHierarchy = CheckpointTypeHierarchy::find()->where(['parent_cp_type' => $rhis->checkpoint_id, 'cp_type' => $rhis->checkbox_id])->one();
        $this->tmp = $checkpointTypeHierarchy->cp_type;
        if ( null == $this->tmp) {
            $checkpointTypeHierarchy = new CheckpointTypeHierarchy();
            $checkpointTypeHierarchy->parent_cp_type = $this->checkpoint_id;
            $checkpointTypeHierarchy->cp_type        = $this->checkbox_id;
            $checkpointTypeHierarchy->save();
        }
    }
}
