<?php

namespace app\models\procedure;

use Yii;
use yii\base\Model;
use app\models\entity\Accounts;
use app\models\entity\AccountsJobtypes;

/*
BEGIN
	declare pr integer;
    declare priv integer;
    
1. получаем приоритет сотрудника

    set priv = (select cmdlevel from accounts where id = sender);

2. обновляем приоритет сотрудника    
    
    if (priv = 2) or (priv = 10) then
		set pr = (select aj.priority from accounts_jobtypes aj where aj.account_id = ac and aj.jobtype_id = jt);
		if (pr is not null) and (pr > 0) then
			update accounts_jobtypes
				set priority = pr
				where account_id = ac and priority = 0;
			update accounts_jobtypes
				set priority = 0
				where account_id = ac and jobtype_id = jt;
		end if;
	end if;
END
*/

class ChangeJobtypePriorityModel extends Model 
{

    private $ac;
    private $jt;
    private $pr;
    private $priv;
    private $sender;

    public function execute($ac, $jt, $sender) 
    {
    
        $this->ac = $ac;
        $this->jt = $jt;
        $this->sender = $sender;
        
//1. получаем приоритет сотрудника
        
        if(!$this->GetCmdlevelAccount()) {
            return false;
        }
        
// 2. Проверяем  на существование тип проекта
        
        if(!$this->UpdateCmdlevelAccount()) {
            return true;
        }
        
        return false;
    }
    
    private function GetCmdlevelAccount() {
            
            $accountsEntity = Accounts::findOne($this->sender);
            $this->priv = $accountsEntity->cmdlevel;
            if ( null == $this->priv){
                return false;
            } 
            return true;
        }
        
        private function UpdateCmdlevelAccount(){
            
            if (( 2 == $this->priv ) || ( 10 == $this->priv )){
                $accountsJobtypesEntity = AccountsJobtypes::find()->where(['account_id' => $this->ac,'jobtype_id' => $this->jt])->one();
                $this->pr = $accountsJobtypesEntity->priority;
                if ( ( null != $this->pr) and ( $this->pr > 0 ) ){
                    AccountsJobtypes::updateAll(['priority' => $this->pr],['account_id' => $this->ac,'priority' => 0]);
                    AccountsJobtypes::updateAll(['priority' => 0],['account_id' => $this->ac,'priority' => $this->jt]);
                    return true;
                }
            }
            return false;
        }
}
