<?php

use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Collection;
use Doctrine\Common\Collections\Criteria;
    
/**
 * @Entity @Table(name="accounts")
 */
class Account extends BaseDBO
{
//    /**
//     * Many Jobtypes have Many Accounts.
//     * @ManyToMany(targetEntity="Jobtype",inversedBy="Account")
//     * @JoinTable(name="accounts_jobtypes",)
//     */
//
//     private $jobtypes_rel;


//    /**
//     * One project has many tasks. This is the inverse side.
//     * @OneToMany(targetEntity="Task", mappedBy="account")
//     */
//    public $tasks;

    /**
     * One account has many tasks. This is the inverse side.
     * @OneToMany(targetEntity="Task", mappedBy="account")
     * @OrderBy({"priority" = "ASC"})
     */
    public $tasks;

    /**
     * One product has many features. This is the inverse side.
     * @OneToMany(targetEntity="AccountJobtype", mappedBy="account", cascade={"persist"}, orphanRemoval = true)
     * @OrderBy({"priority" = "ASC"})
     */
    private $accountJobtypes;
     
     public function __construct() {
//        $this->jobtypes_rel = new ArrayCollection();
//
        $this->tasks = new \Doctrine\Common\Collections\ArrayCollection();
        $this->accountJobtypes = new \Doctrine\Common\Collections\ArrayCollection();
    }

     /**
     * @Id @Column(type="integer") @GeneratedValue
     */
    protected $id;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $hash;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $name;

    /**
     * @var boolean
     *
     * @Column(type="smallint")
     */
    private $cmdlevel;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $phone;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $password;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $uuid;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $position;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $employee_status;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $login;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $email;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $skype;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    public $basic_jobs_count;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $active_company;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $active_device_id;

//    /**
//     * @var string
//     *
//     * @Column(type="string")
//     */
//    private $active_task_ids;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    private $created;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $jobtypes;

    /**
     * @Column(type="integer")
     */
    public $overplan_mode;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    private $last_seen_mobile;

    /**
     *
     * @Column(type="datetime")
     */
    public $last_push_message_sent;


    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    private $last_seen_web;
    
    /**
     * @ManyToOne(targetEntity="Company", inversedBy="assignedCompanies")
     * @JoinColumn(name="company", referencedColumnName="id")
     */
    protected $company;

    /**
     * @Column(type="string")
     */
    public $android_token_id;

    /**
     * @Column(type="integer")
     */
    public $quit_set;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    public $last_action;


    function getBasic()
    {
        $criteria = new Criteria(null, ['priority' => 'ASC']);
        $criteria->setMaxResults($this->basic_jobs_count);
        return $this->accountJobtypes->matching($criteria);
    }

    public static function ClearTasksFromAccount($acc_id, $debugtext = true, $refuseTaskId = 0, $all = false)
    {
        if (!$acc_id)
            return;
        global $link;
        /**
         * @var $account Account
         */
        $account = Account::Find($acc_id);
        if ($account != null)
        {
            $account->ClearTasks($debugtext, $refuseTaskId, $all);
        }
    }

    function ClearTasks($debugtext = true, $refuseTaskId = 0, $all = false)
    {
        global $link;
        if ($all)
            $tasks = $this->tasks;
        else
            $tasks = $this->getActiveTasks();
        
        if (sizeof($tasks) > 0 && $debugtext) {
            echo "<span style='color:red'><b> Задачи аккаунта $this->id очищены!</b></span>";
            EnqueueCMD($this->id, "21");
        }
        foreach ($tasks as $task)
        {
            /**
             * @var $task Task
             */
            if ($refuseTaskId > 0)
            {
                if ($task->id == $refuseTaskId || $task->parent_id == $refuseTaskId)
                    $task->ClearAssignee(false);
            }
            else
                $task->ClearAssignee(false);
        }
        $this->Save();
        if ($refuseTaskId > 0)
        {
            mysqli_query($link, "insert into refuses (created, main_task_id, account_id) values(NOW(), $refuseTaskId, $this->id)");
        }
        OCScleartasks($this->id);
    }

    public function getFirstActiveTaskMain() {
        $expressionBuilder = Criteria::expr();

        $expression = $expressionBuilder->andX(
            $expressionBuilder->eq('assignees_arr', $this->id),
            $expressionBuilder->eq('priority', 0),
            $expressionBuilder->neq('input_id', 0),
            $expressionBuilder->neq('input_id', NULL),
            $expressionBuilder->neq('status', 5)
        );

        if ($this->tasks != null) {
            return $this->tasks->matching(new Criteria($expression, ['input_id' => 'ASC']))->first();
        }
        return array();
    }

    public function getActiveTasks() {
        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->neq('status', 5);
        if ($this->tasks != null) {
            return $this->tasks->matching(new Criteria($expression, ['id' => 'ASC']));
        }
        return array();
    }

    public function getAssignedTasks() {

        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->eq('status', 2);
        return $this->tasks->matching(new Criteria($expression, ['priority' => 'ASC']));
    }

    public function getPausedTasks() {

        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->eq('status', 4);
        return $this->tasks->matching(new Criteria($expression, ['priority' => 'ASC']));
    }

    public function getAcceptedTasks() {

        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->eq('status', 3);
        return $this->tasks->matching(new Criteria($expression, ['id' => 'ASC']));
    }

    public function getCompany()
    {
        return $this->company;
    }
    
    public function setCompany()
    {
        $this->company->assignedCompanies($this);
        $this->company = $this->company;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getName()
    {
        return $this->name;
    }

    public function setName(string $name)
    {
        $this->name = $name;

        return $this;
    }

    public function getCmdlevel()
    {
        return $this->cmdlevel;
    }

    public function setCmdlevel(bool $cmdlevel)
    {
        $this->cmdlevel = $cmdlevel;

        return $this;
    }

    public function getPhone()
    {
        return $this->phone;
    }

    public function setPhone(string $phone)
    {
        $this->phone = $phone;

        return $this;
    }

    public function getPassword()
    {
        return $this->password;
    }

    public function setPassword(string $password)
    {
        $this->password = $password;

        return $this;
    }

    public function getLogin()
    {
        return $this->login;
    }

    public function setLogin(string $login)
    {
        $this->login = $login;

        return $this;
    }

    public function getEmail()
    {
        return $this->email;
    }

    public function setEmail(string $email)
    {
        $this->email = $email;

        return $this;
    }

    public function getSkype()
    {
        return $this->skype;
    }

    public function setSkype(string $skype)
    {
        $this->skype = $skype;

        return $this;
    }



    public function getActiveCompany()
    {
        return $this->active_company;
    }

    public function setActiveCompany(int $active_company)
    {
        $this->active_company = $active_company;

        return $this;
    }

    public function getActiveDeviceId()
    {
        return $this->active_device_id;
    }

    public function setActiveDeviceId(string $active_device_id)
    {
        $this->active_device_id = $active_device_id;

        return $this;
    }

    public function getCreated()
    {
        return $this->created;
    }

    public function setCreated(\DateTime $created)
    {
        $this->created = $created;

        return $this;
    }


    public function getLastSeenMobile()
    {
        return $this->last_seen_mobile;
    }

    public function setLastSeenMobile($last_seen_mobile)
    {
        $this->last_seen_mobile = $last_seen_mobile;

        return $this;
    }

    public function getLastSeenWeb()
    {
        return $this->last_seen_web;
    }

    public function setLastSeenWeb($last_seen_web)
    {
        $this->last_seen_web = $last_seen_web;

        return $this;
    }

    public function getJobtypes()
    {
        $arr = array();
        foreach ($this->accountJobtypes as $ajt)
        {
            array_push($arr, $ajt->jobtype);
        }
        return $arr;
    }

    public function getPrimaryJobtypes()
    {
        $primaryJobs = array();
        $count = 0;
        while ($count < $this->basic_jobs_count)
        {
            $ajt = $this->accountJobtypes[$count];
            $count++;
            array_push($primaryJobs, $ajt->jobtype);
        }

        return $primaryJobs;
    }

    public function getJobtypesExtended()
    {
        $primaryJobs = array();
        $secondaryJobs = array();
        $count = 0;

        foreach ($this->accountJobtypes as $ajt)
        {
            if ($count < $this->basic_jobs_count)
                array_push($primaryJobs, $ajt->jobtype);
            else
                array_push($secondaryJobs, $ajt->jobtype);
            $count++;
        }
        return [$primaryJobs, $secondaryJobs];
    }

    public function getJobtypesIds()
    {
        $jobs = $this->getJobtypes();
        $job_ids_account = array();
        foreach ($jobs as $job)
        {
            array_push($job_ids_account, $job->id);
        }
        return $job_ids_account;
    }

    public function hasJobtype(Jobtype $jobtype)
    {
        if (in_array($jobtype, $this->getJobtypes()))
            return true;
        return false;
    }

    public function clearJobtypes()
    {
        foreach ($this->accountJobtypes as $ajt)
        {
            $ajt->jobtype->accountJobtypes = new \Doctrine\Common\Collections\ArrayCollection();
            $ajt->jobtype = null;
            $ajt->account = null;
        }
        $this->accountJobtypes = new \Doctrine\Common\Collections\ArrayCollection();
    }

    public function removeJobtype(Jobtype $jobtype)
    {
        $todel = array();
        foreach ($this->accountJobtypes as $ajt)
        {
            if ($ajt->jobtype->id == $jobtype->id)
            {
                array_push($todel, $ajt);
            }
        }
        foreach ($todel as $ajt) {
            $ajt->jobtype = null;
            $ajt->account = null;
            $this->accountJobtypes->removeElement($ajt);
            $jobtype->accountJobtypes->removeElement($ajt);
        }
    }

    public function changeJobtype($prevId, $newId, $priority)
    {
//        echo "changeJobtype ".sizeof($this->accountJobtypes);
        foreach ($this->accountJobtypes as $ajt)
        {
//            echo "prev $prevId cur ".$ajt->jobtype->id;
            if ($ajt->jobtype->id == $prevId)
            {
//                echo "found $prevId";
                $newjob = Jobtype::Find($newId);

                $ajt->jobtype = $newjob;
                $ajt->priority = $priority;
                $ajt->Save();
                break;
            }
        }
        $this->Save();
    }

    public function addJobtype(Jobtype $jobtype, $priority=-1)
    {
            $ajt = new AccountJobtype();
            if ($priority != -1)
                $ajt->priority = $priority;
            $ajt->jobtype = $jobtype;
            $ajt->account = $this;

            $this->accountJobtypes[] = $ajt;
            $jobtype->accountJobtypes[] = $ajt;
    }

    function UpdateJob($newjobid, $jobindex, $previous)
    {
      
        global $link;
        if (!$link)
            include 'auth.php';
        require_once 'functions.php';
        $account = $this;
        $jobs = array_filter(GetAccountJobs($this->id));
//        var_dump($newjobid);
//    var_dump($previous);
    //var_dump($account->id);exit;
        if ($newjobid == 'deletejob') {
            if ($account != null) {
                $jobtype = Jobtype::Find($previous);
            //var_dump($jobtype->id);
                if ($jobtype != null && $account->hasJobtype($jobtype)) {
                    $account->removeJobtype($jobtype);
                    $account->Save();
//                print_r($jobs); echo "ji $jobindex<br>";
                    array_splice($jobs, $jobindex, 1);
//                print_r($jobs); echo "2<br>";
                }
            }
        }
        else {
            $jobs[$jobindex] = $newjobid;
        }
            $jobstr = implode(',', $jobs);
//    echo "jbstr $jobstr";
            $account->changeJobtype($previous, $newjobid, $jobindex);
        mysqli_query($link, "update accounts set jobtypes='" . $jobstr . "' where id=" . $this->id);

    }
}

