<?php

//use Doctrine\Common\Collections\ArrayCollection;
use Doctrine\Common\Collections\Criteria;
/**
 * @Entity @Table(name="companies")
 */
class Company extends BaseDBO
{
     /**
     * @Id @Column(type="integer") @GeneratedValue
     */
    protected $id;

    /**
     *@Column(type="integer")
     */
    private $confirm_default_timeout_seconds;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $name;

    /**
     * @Column(type="datetime")
     */
    public $last_assign;

    /**
     * @Column(type="datetime")
     */
    public $last_invalid_tasks_check;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $ceo;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $address;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $active;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $logo;

    /**
     * @OneToMany(targetEntity="Account", mappedBy="company")
     */
    public $accounts;

    //        $criteria = Criteria::create()->orderBy(['id', 'DESC']);

    public function CheckInvalidTasks($verbose=false)
    {
        $taskcheckInterval = 60;
        $clearTasksTimeoutCommon = 600;
        $clearTasksTimeout_AsuSg = 5400;
        global $entityManager, $link;

        $last_invalid_tasks_check = strtotime(TimeString($this->last_invalid_tasks_check));
        $time = (time()-$last_invalid_tasks_check);

        if (!$verbose && $time < $taskcheckInterval)
        {
            return null;
        }
        $date = new \DateTime("now");
        $tz = new \DateTimeZone('Europe/Moscow');
        $date->setTimezone($tz);
        $this->last_invalid_tasks_check = $date;
        $this->Save();

        //Выданные но непринятые!
        $query = $entityManager->createQuery("SELECT t FROM Task t WHERE t.status = 2 AND t.parent_id > 0 AND DATE_SUB(CURRENT_TIMESTAMP(), 10, 'MINUTE') > t.assigned ORDER BY t.id DESC");
        $accSkip = array();
//        $query->setMaxResults(200);
        $tasks = $query->getResult();
        foreach ($tasks as $task)
        {
            /**
             * @var $task Task
             */
            if ($task->assignees_arr > 0) {
                $acc = $task->account;
                if (isset($acc)) {
                    if ($verbose)
                        echo "<br><br>acc $acc->id<br>";
                    if (intval($accSkip[$acc->id]) > 0) {
                        $acceptedTaskLen = sizeof($acc->getAcceptedTasks());
                        if ($acceptedTaskLen > 0) {
                            $accSkip[] = $acc->id;
                            if ($verbose)
                                echo "<br><br>skip acc $acc->id";
                            continue;
                        }
                        $lastaction = strtotime(TimeString($acc->last_action));

                        if ($task->asusg_job_mapped_id)
                            $interval = $clearTasksTimeout_AsuSg;
                        else
                            $interval = $clearTasksTimeoutCommon;

                        $time = (time() - $lastaction);
                        if ($verbose)
                            echo "<br><br>time $time";
                        if ($time > $interval) {
                            $acc->ClearTasks(false, $task->parent_id);
                            require_once "../functions.php";
                            WriteLog($acc->id, "cleartasks");
                            if ($verbose)
                                echo "<br> $acc->id cleartasks";
                            continue;
//                        mysqli_query($link, "insert into refuses (created, main_task_id, account_id) values(NOW(), $task->id, $task->assignees_arr)");
//                        $task->ClearAssignee();
                        }
                    }
                }
            }
        }
        if ($verbose) {
            \Doctrine\Common\Util\Debug::dump($tasks);
        }

        //Принятые!
//        $query2 = $entityManager->createQuery("SELECT t FROM Task t WHERE t.status = 3 AND DATE_SUB(CURRENT_TIMESTAMP(), 60, 'MINUTE') > t.accepted_time ORDER BY t.id DESC");
//        $tasks2 = $query2->getResult();
//
//        if ($verbose) {
//            echo "<br><br>Подвисшие задачи: ";
//            \Doctrine\Common\Util\Debug::dump($tasks2);
//            echo "<br><br><br>";
//        }
//        foreach ($tasks2 as $task)
//        {
//            $acc_id = $task->assignees_arr;
//            if ($acc_id > 0) {
//                $acc = Account::Find($acc_id);
//                if ($acc) {
//                    $lastaction = strtotime(TimeString($acc->last_action));
//                    $time = (time() - $lastaction);
//                    if ($time > 600) {
//                        mysqli_query($link, "insert into penalties (account_id, task_id, created) values ($task->assignees_arr, $task->id, NOW())");
//                        mysqli_query($link, "insert into text_log (msg, stamp) values ('Cleartasks $acc_id', NOW())");
//                        $acc->ClearTasks(false);
//                    }
//                }
//            }
//        }

    }

    public function GetConfirmTimeout()
    {
        return $this->confirm_default_timeout_seconds;
    }

    public function getUrgentProjects()
    {
        global $entityManager;
        $projs = $entityManager->getRepository('Project')->findBy(array('company' => $this->id, "urgent" => 1));
        return $projs;
    }

    function getAccountsDesc()
    {
        $criteria = new Criteria(null, ['id' => 'DESC']);
        $criteria->setMaxResults(2);
        return $this->accounts->matching($criteria);
    }

    public function GetLazyAccounts()
    {
        global $onlineMobileTimeoutSeconds;
        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->andX(
            $expressionBuilder->gt('cmdlevel', 0),
            $expressionBuilder->gt('last_seen_mobile',  new \DateTime("-$onlineMobileTimeoutSeconds"."seconds"))
        );
        $criteria = new Criteria($expression, ['id' => 'ASC']);

        $arr = array();

        $accs = $this->accounts->matching($criteria);
        foreach ($accs as $acc) {
            if (sizeof($acc->getAssignedTasks()) > 0 && sizeof($acc->getAcceptedTasks())==0 )
                array_push($arr, $acc);
        }

        return $arr;
    }

    public function GetOfflineAccounts($echo=false)
    {
//	echo "GetOfflineAccounts";
        global $onlineMobileTimeoutSeconds;
        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->andX(
            $expressionBuilder->gt('cmdlevel', 0),
            $expressionBuilder->lt('last_seen_mobile',  new \DateTime("-$onlineMobileTimeoutSeconds"."seconds"))
        );
        $criteria = new Criteria($expression, ['id' => 'ASC']);

        $arr = array();

        $accs = $this->accounts->matching($criteria);
        foreach ($accs as $acc) {

            $accid = $acc->id;
            if (!$acc->quit_set)
            {
                $acc->quit_set = 1;

                $acc->Save();
                if ($echo)
                    var_dump ($accid);
                $tagid = GetVagrantTagID($accid);
                if ($tagid)
                {
                    if ($echo)
                        var_dump ($tagid);
                    OCSlogoff($accid);
                    VagrantRequest($accid, $tagid, $acc->name, 2);
                }
            }

            array_push($arr, $acc);
        }
        return $arr;
    }

    public function GetOnlineAccounts(bool $exclude_overplan = false, bool $exclude_urgent = false)
    {
        global $link, $onlineMobileTimeoutSeconds;

        $expressionBuilder = Criteria::expr();
        if ($exclude_overplan) {
            $expression = $expressionBuilder->andX(
                $expressionBuilder->gt('cmdlevel', 0),
                $expressionBuilder->neq('overplan_mode', 1),
                $expressionBuilder->gt('last_seen_mobile', new \DateTime("-$onlineMobileTimeoutSeconds" . "seconds"))
            );
        }
        else
        {
            $expression = $expressionBuilder->andX(
                $expressionBuilder->gt('cmdlevel', 0),
                $expressionBuilder->gt('last_seen_mobile', new \DateTime("-$onlineMobileTimeoutSeconds" . "seconds"))
            );
        }

        $criteria = new Criteria($expression, ['id' => 'ASC']);

        $arr = array();

        $accs = $this->accounts->matching($criteria);
        foreach ($accs as $acc) {
            if ($exclude_urgent)
            {
                $urgentAcciountIds = FindUrgentAccounts();
                if (!in_array($acc->id, $urgentAcciountIds))
                    array_push($arr, $acc);
            }
            else
                array_push($arr, $acc);
        }
        return $arr;
    }

    //онлайн аккаунты с задачами на паузе
    public function GetPausedAccounts()
    {
        global $onlineMobileTimeoutSeconds;
        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->andX(
            $expressionBuilder->gt('cmdlevel', 0),
            $expressionBuilder->gt('last_seen_mobile',  new \DateTime("-$onlineMobileTimeoutSeconds"."seconds"))
        );
        $criteria = new Criteria($expression, ['id' => 'ASC']);

        $arr = array();

        $accs = $this->accounts->matching($criteria);
        foreach ($accs as $acc) {
            if (sizeof($acc->getPausedTasks()) == 0)
                array_push($arr, $acc);
        }
        return $arr;
    }

    //онлайн аккаунты без задач
    public function GetIdleAccounts()
    {
        global $onlineMobileTimeoutSeconds;
        $expressionBuilder = Criteria::expr();
        $expression = $expressionBuilder->andX(
            $expressionBuilder->gt('cmdlevel', 0),
            $expressionBuilder->neq('overplan_mode', 1),
            $expressionBuilder->gt('last_seen_mobile',  new \DateTime("-$onlineMobileTimeoutSeconds"."seconds"))
        );
        $criteria = new Criteria($expression, ['id' => 'ASC']);

        $arr = array();

        $accs = $this->accounts->matching($criteria);
        foreach ($accs as $acc) {
            if (sizeof($acc->getActiveTasks()) == 0)
                array_push($arr, $acc);
        }
        return $arr;
    }


    /**
     * @OneToMany(targetEntity="Location", mappedBy="company")
     */
    public $locations;
    
    public function __construct()
    {
        $this->assignedCompanies = new ArrayCollection();
        $this->locations = new ArrayCollection();
        $this->accounts = new ArrayCollection();
    }

    public function getId(): int
    {
        return $this->id;
    }

    public function getName(): string
    {
        return $this->name;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getCeo(): string
    {
        return $this->ceo;
    }

    public function setCeo(string $ceo): self
    {
        $this->ceo = $ceo;

        return $this;
    }

    public function getAddress(): string
    {
        return $this->address;
    }

    public function setAddress(string $address): self
    {
        $this->address = $address;

        return $this;
    }

    public function getActive(): string
    {
        return $this->active;
    }

    public function setActive(string $active): self
    {
        $this->active = $active;

        return $this;
    }

    public function getLogo(): string
    {
        return $this->logo;
    }

    public function setLogo(string $logo): self
    {
        $this->logo = $logo;

        return $this;
    }
}

