<?php
//use Doctrine\Common\Collections\ArrayCollection;


 /**
 * @Entity @Table(name="jobtypes")
 */

class Jobtype extends BaseDBO
{
//    /**
//     * Many Jobtypes have Many Accounts.
//     * @ManyToMany(targetEntity="Account",inversedBy="jobtypes")
//     * @JoinTable(name="accounts_jobtypes",)
//     */
//    private $accounts;

    /**
     * One product has many features. This is the inverse side.
     * @OneToMany(targetEntity="AccountJobtype", mappedBy="jobtype", cascade={"persist"}, orphanRemoval = true)
     */
    public $accountJobtypes;
    
    /**
     * Many Jobtype have Many Tasktypes.
     * @ManyToMany(targetEntity="Tasktype",inversedBy="jobtypes")
     * @JoinTable(name="jobtypes_tasktypes")
     */
    private $tasktypesrel;
     
    public function __construct() {
        $this->tasktypesrel = new \Doctrine\Common\Collections\ArrayCollection();
        $this->accountJobtypes = new \Doctrine\Common\Collections\ArrayCollection();
    }
    /**
     * @Id @Column(type="integer") @GeneratedValue
     */
    private $id;
    public function __get($id)
    {
        return $this->id;
    }

    /** @Column(type="string") */
    public $name;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $company;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $tasktypes;

    public function getId(): int
    {
        return $this->id;
    }

    public function setName(string $name): self
    {
        $this->name = $name;

        return $this;
    }

    public function getCompany(): int
    {
        return $this->company;
    }

    public function setCompany(int $company): self
    {
        $this->company = $company;

        return $this;
    }

//    public function getTasktypes(): string
//    {
//        return $this->tasktypes;
//    }
//
//    public function setTasktypes(string $tasktypes): self
//    {
//        $this->tasktypes = $tasktypes;
//
//        return $this;
//    }
    
//    public function getAccountsRel()
//    {
//        return $this->accounts;
//    }
    public function getAccounts(): array
    {
        $arr = array();
        foreach ($this->accountJobtypes as $ajt)
        {
            array_push($arr, $ajt->account);
        }
        return $arr;
    }
    
    public function getTaskTypes()
    {
        return $this->tasktypesrel;
    }

    public function deleteTasktype($key)
    {
        return $this->tasktypesrel->removeElement($key);
    }

    public function addAcсountJobtypes(Account $account)
    {
        return $this->accounts[] = $account;
    }
    
    public function addTasktype(Tasktype $tasktype)
    {
        return $this->tasktypesrel[] = $tasktype;
    }

    public static function ConvertJobtypes(Account $account)
    {
        echo "convert $account->id: ";
        $jobtypesarr = explode(",",$account->jobtypes);
        $jobtypesarr = array_filter($jobtypesarr);

        var_dump($jobtypesarr);
        echo "<br>";
        foreach ($jobtypesarr as $jid) {
            $jobtype = Jobtype::Find($jid);
            if ($jobtype != null) {
                $account->addJobtype($jobtype);
            }
        }
        $account->Save();
    }

    public function addAccount(AccountJobtype $ajt)
    {
        if ($this->accountJobtypes->contains($ajt)) {
            return;
        }
        $this->accountJobtypes[] = $ajt;
    }
}

