<?php
use CheckPoints\CheckPoint;
use CheckPointTypes\CheckPointType;
use Doctrine\Common\Collections\Criteria;
/**
 * @Entity @Table(name="projects_locotech")
 */

class Project extends BaseDBO implements ArrayExpressible
{
    /**
     * One project has many tasks. This is the inverse side.
     * @OneToMany(targetEntity="Task", mappedBy="project")
     */
    private $tasks;
    
    /**
     * @ManyToOne(targetEntity="ProjectType", inversedBy="projects")
     * @JoinColumn(name="action", referencedColumnName="id")
     */
    public $projecttype;

    /**
     * @ManyToOne(targetEntity="Section", inversedBy="projects")
     * @JoinColumn(name="section_id", referencedColumnName="id")
     */
    public $section;

    /**
     * @var array
     */
    public $sections;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    public $result_id;

    /**
     * @Id @Column(type="integer") @GeneratedValue
    */
    protected $id;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    public $urgent;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $action;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $company;

    /**
     *
     * @Column(type="smallint")
     */
    private $status;

    /**
     *
     * @Column(type="string")
     */
    public $loco_type;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    public $loco_number;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $depo;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $depo_service;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    private $created;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    public $started;

    /**
     * @var string
     *
     * @Column(type="string")
     */
    private $uuid;

    /**
     * @var \DateTime
     *
     * @Column(type="datetime")
     */
    public $finished_time;

    /**
     * @var integer
     *
     * @Column(type="integer")
     */
    private $finished_person;

    public function __construct() {
        $this->projectTypes = new \Doctrine\Common\Collections\ArrayCollection();
        $this->tasks = new \Doctrine\Common\Collections\ArrayCollection();
        $this->sections = array();
    }

    public function toArray() {
        return get_object_vars($this);
    }

    public function Complete($userId = 0)
    {
        $tasks = $this->getTasks();
        foreach ($tasks as $task)
        {
            /** @var $task Task */
            $task->status = 5;
        }
        $this->setStatus(5);
        $this->finished_person = $userId;
        $this->finished_time = new DateTime();
        $this->Save();
    }

    public function checkPointsWrite($echo=false) {

//        echo "checkPointsWrite";

        $result = "";
        global $entityManager, $link;
        $arr = array();
        $resultString = "";
        $notesCount = 0;
        $cpCount = 0;
        foreach ($this->tasks as $task) {
		if ($task->asusg_job_mapped_id > 0)
			continue;

                $tasktype = \Tasktype::Find($task->type);

             /**
             * @var $tasktype Tasktype
             */
            /**
             * @var $task Task
             */
            /**
             * @var $series LocoSeries
             */
            $section = $task->getSection();
             $series = $section->series;
                CheckSection($section->letter, $series->name, $section->getSectionNumber(), $section->getSectionSubnumber());
                $arr[$task->id] = $task->type;
                $taskid = $task->id;
                $cps = CheckPoint::FindAllByTask($taskid);
//                if ($echo) {
//                    echo "<br><br>found cps:";
//                    var_dump($cps);
//                    echo "<br>";
//                }

                //чекпойнты у задачи
                foreach ($cps as $cp)
                {
                    //варианты чекпойнта

                    /**
                     *  @var $task Task
                     *  @var $cp CheckPoint
                     */
                    $cpnotes = "";
                    if ($cp->parentCheckpointId == 0)
                    {
                        $textnotes = $entityManager->getRepository('Tasknote')->findBy(array('checkpoint_id' => $cp->id));
                        foreach ($textnotes as $tn) {
                            $cpnote = $tn->text;
                            $cpnotes .= ". Замечание: $cpnote";
                        }
                        $result = $cp->AddRemark($echo, $task, $tasktype, $cpnotes);
                        $cpCount++;
                        if ($result)
                            $resultString .= $result."<br><br>";

                    }
                }

                $notes = FindTaskNotes($taskid);

                if (sizeof($notes) > 0) {
                    foreach ($notes as $note) {
                        if (!$note['checkpoint_id']) {
                            $notesCount++;
                            $notedate = $note['date'];
                            $noteid = $note['id'];
                            $notetext = $note['text'];

                            $text =  "$noteid. [$tasktype->name] $notetext";

                            $tasknote = Tasknote::Find($noteid);
                            if ($echo)
                            {
                                var_dump($text);
                                \Doctrine\Common\Util\Debug::dump($tasknote);
                            }

                            $result = $task->AddRemark($text);
                            if ($result)
                                $resultString .= $result."<br><br>";
                            if ($echo)
                            {
                                var_dump($result);
                            }
                            $json = json_decode($result);
                            if ($json != null)
                            {
                                $tasknote->remark_id = $json->RemarkId;
                                $tasknote->code1c = $json->Kod;
                                $tasknote->guid = $json->Guid;
                                $tasknote->twx_result = $result;
                                $tasknote->Save();
                            }
                        }
                    }
                }
        }
        echo "<b>Notes: $notesCount<br>CheckPoints: $cpCount<br>Result:</b><br>".$resultString;
        return $arr;
    }

    function getSections()
    {
        global $entityManager;
        $series = $this->getLocoType();
        $number = $this->loco_number;
        $sec = $entityManager->getRepository('Section')->findBy(array('locomotive_series' => $series, 'section_number' => $number));
        return $sec;
        //\Doctrine\Common\Util\Debug::dump($sec);
    }

//    public function AddRemarks($account, $text)
//    {
//        /**
//         * @var $section Section
//         */
//        $sections = $this->getSections();
//
//        foreach ($sections as $section) {
//            if ($section != null) {
//                $section->AddRemark($account, $text);
//            }
//        }
//    }

//    public function AddSection($loco_type, $number, $subnumber)
//    {
//        $sections = Section::FindByNumbers($loco_type, $number, $subnumber);
//        if (sizeof($sections) == 0) {
//            $section = new Section();
//            var_dump($loco_type);
////            $section->setLocomotiveSeries($loco_type);
//            $series = LocoSeries::FindByName($loco_type);
//            if ($series != null) {
//                $section->series = $series;
//                $section->setSectionNumber($number);
//                $section->setSectionSubnumber($subnumber);
//                $this->section = $section;
//                $section->Save();
//                return $section;
//            }
//            else
//            {
//                return null;
//            }
//        }
//        else {
////            var_dump($sections);
//            $this->section =  $sections[0];
//            $this->Save();
//            return $sections[0];
//        }
//    }

    public function AddCompletedWork()
    {
        $locomotiveModel = new app\models\LocomotiveModel();
        $now = $locomotiveModel->milliseconds();

        $params['number'] = $this->section->getSectionNumber(); // номер секции
        $params['subnumber'] = $this->section->getSectionSubnumber();
        $params['diagnosticCard'] = $this->diagnostic_card;
        $params['inspectionId'] = "\"$this->id\""; // ид проекта
        $params['isSCWorksNeeded'] = 'false';
        $params['startTime'] = $this->GetStartTime();//начало выполнения первого таска
        $params['endTime'] = $now; // завершение последнего
        $params['worker'] = $this->GetWorkers();
        $params['engineer'] = '0';
        $params['otcEmployee'] = '0';
        $result = $locomotiveModel->addCompletedWork($params);
        $resultId = json_decode($result)->id;
        $this->result_id = $resultId;
        $this->Save();
        //$result_uuid
        return $result;
        //        var_dump($result);
    }

    public function GetStartTime()
    {
        if (sizeof($this->tasks) > 0)
            return BaseDBO::TimeString($this->tasks[0]->created);
    }

    public function GetWorkers()
    {
        $array_workers = array();
        $accids = array();
        foreach ($this->tasks as $task)
        {
            $taskWorkers = explode(",", $task->assignees_arr);
            foreach ($taskWorkers as $worker)
            {
                if (!$worker)
                    continue;
                if (!$accids[$worker]) {
                    $accids[$worker] = 1;
                    array_push($array_workers, $worker);
                }
            }
        }
        return $array_workers;
    }

    public function reopenTasks()
    {
        foreach ($this->tasks as $task)
        {
            $task->assignees_arr = 0;
        }
        $this->Save();
    }

    public function getTasks($account_id = 0)
    {
        if (!$account_id)
            return $this->tasks;
        else
        {
            $expressionBuilder = Criteria::expr();
            $expression = $expressionBuilder->eq('assignees_arr', $account_id);
            if ($this->tasks != null) {
                return $this->tasks->matching(new Criteria($expression, ['priority' => 'ASC']));
            }
            return array();
        }
    }

    public function getPrimaryTasks($account_id = 0, $main=null, $verbose=0)
    {
        if (!$account_id)
            return $this->tasks;
        else
        {
            $arr = array();
            $expressionBuilder = Criteria::expr();
            $expression = $expressionBuilder->andX(
                $expressionBuilder->eq('assignees_arr', $account_id),
                $expressionBuilder->eq('priority', 0),
                $expressionBuilder->neq('status', 5)
            );

//            $expression = $expressionBuilder->eq('assignees_arr', $account_id);
                if ($this->tasks != null) {
                    if (!$main)
                        $retval =  $this->tasks->matching(new Criteria($expression, ['id' => 'ASC']))->first();
                    else
                        $retval =  $main;
            }
            if ($verbose)
            {
                \Doctrine\Common\Util\Debug::dump($retval);
                echo "<br>main found for $account_id";
                var_dump($retval->id);
                echo "<br><br>";
            }

            if ($retval) {
                $expression2 = $expressionBuilder->andX(
                    $expressionBuilder->eq('parent_id', $retval->id),
                    $expressionBuilder->eq('assignees_arr', $account_id),
                    $expressionBuilder->neq('status', 5)
                );
                $retval2 = $this->tasks->matching(new Criteria($expression2, ['priority' => 'ASC']));
                if ($verbose)
                {
                    \Doctrine\Common\Util\Debug::dump($retval2);
                }
                if (sizeof($retval2) > 0) {
                    $arr[] = $retval;
                    foreach ($retval2 as $task) {
                        $arr[] = $task;
                    }
                }
            }
            return $arr;
            //return array();
        }
    }

    public function addTask(Task $task)
    {
        $this->tasks[] = $task;
    }

    public function getActions()
    {
        return $this->actions;
    }

    public function setActions(ProjectType $actions)
    {
        $this->actions = $actions;
    }

    public function getId()
    {
        return $this->id;
    }

    public function getProjectType()
    {
        return ProjectType::Find($this->action);
    }

    public function getAction()
    {
        return $this->action;
    }

    public function setAction(int $action)
    {
        $this->action = $action;

        return $this;
    }

    public function getCompany()
    {
        return $this->company;
    }

    public function setCompany(int $company)
    {
        $this->company = $company;

        return $this;
    }

    public function getStatus()
    {
        return $this->status;
    }

    public function setStatus($status)
    {
        $this->status = $status;
    }

    public function getLocoType()
    {
        return $this->loco_type;
    }

    public function setLocoType($locoType)
    {
        $this->loco_type = $locoType;

        return $this;
    }

    public function getDepo()
    {
        return $this->depo;
    }

    public function setDepo(string $depo)
    {
        $this->depo = $depo;

        return $this;
    }

    public function getDepoService()
    {
        return $this->depo_service;
    }

    public function setDepoService(string $depoService)
    {
        $this->depo_service = $depoService;

        return $this;
    }

    public function getCreated()
    {
        return $this->created;
    }

    public function setCreated($created)
    {
        $this->created = $created;

        return $this;
    }

    public function getUuid()
    {
        return $this->uuid;
    }

    public function setUuid($uuid)
    {
        $this->uuid = $uuid;

        return $this;
    }
}

