<?php
/**
 * @Entity @Table(name="projecttypes")
 */

class ProjectType extends BaseDBO
{
    /**
     * @ManyToMany(targetEntity="LocoSeries",mappedBy="projecttypes")
     *  @OrderBy({"name" = "ASC"})
     */
    public $series;

    /**
     * One product has many features. This is the inverse side.
     * @OneToMany(targetEntity="Project", mappedBy="projecttype")
     */
    private $projects;

    /**
     * One product has many features. This is the inverse side.
     * @OneToMany(targetEntity="ProjecttypeTasktype", mappedBy="projecttype", cascade={"persist"})
     * @OrderBy({"priority" = "ASC"})
     */
    private $projecttypeTasktypes;


//    /**
//     * Many ProjectType have Many Tasktypes.
//     * @ManyToMany(targetEntity="Tasktype",inversedBy="projecttypes")
//     * @JoinTable(name="projecttypes_tasktypes")
//     */
//    private $tasktypes;

    public function __construct() {
        $this->projecttypeTasktypes = new \Doctrine\Common\Collections\ArrayCollection();
//        $this->tasktypes = new \Doctrine\Common\Collections\ArrayCollection();
//        $this->projects = new \Doctrine\Common\Collections\ArrayCollection();
    }

    public function addSeries(LocoSeries $series)
    {
        $this->series[] = $series;
        $series->projecttypes[] = $this;
    }

    public function addTasktype(ProjecttypeTasktype $pttt)
    {

        //$pttt->Save();

        if ($this->projecttypeTasktypes->contains($pttt)) {
            return;
        }
        $this->projecttypeTasktypes[] = $pttt;
    }

    public function removeTasktype(ProjecttypeTasktype $pttt)
    {
        if (!$this->projecttypeTasktypes->contains($pttt)) {
            return;
        }
        $this->projecttypeTasktypes->removeElement($pttt);
        //$tasktype->removeProjectype($this);

//        global $entityManager;
//        //getRepository('MyProject\Domain\User')->findBy(array('age' => 20, 'surname' => 'Miller'));
////        $pttt = $entityManager->getRepository('ProjecttypeTasktype')->findBy(array('projecttype_id' => $this->id, 'tasktype_id' => $tasktype->id), array('priority' => 'ASC'));
//        $entityManager->remove($pttt);
//        $pttt->Save();
    }

    public function GetJobTypes()
    {
        $tasktypes = $this->getTasktypes();

        $jtypes = array();
        foreach ($tasktypes as $tt)
        {
            /**
             * @var $tt Tasktype
             */
            $subs = explode(',',$tt->subtasks);
            //IN?
//            return $entityManager->getRepository('Tasktype')->findBy(array('parent_id' => $this->id));
            foreach ($subs as $sub)
            {
                $tasktype = Tasktype::Find(intval($sub));
                $jobtypes = $tasktype->getJobtypes();
                $jtypes = array_merge($jtypes, $jobtypes->toArray());
            }
        }
//        $jtypes = array_unique($jtypes);
        $jtypes = array_filter($jtypes);
        return new \Doctrine\Common\Collections\ArrayCollection($jtypes);
    }


    public function GetAccounts()
    {
        $jobtypes = $this->GetJobTypes();
        $accs = array();
        $accids = array();
        foreach ($jobtypes as $jt)
        {
            /**
             * @var $jt Jobtype
             */
            $accounts = $jt->getAccounts();
            foreach ($accounts as $acc)
            {
                if (!$accids[$acc->id]) {
                    $accids[$acc->id] = 1;
                    array_push($accs, $acc);
                }
            }
        }
        return  array_filter($accs);
    }

    public function getProjecttypesTasktypes()
    {
        return $this->projecttypeTasktypes;
    }

    public function getTasktypes()
    {
        $arr = array();
        foreach ($this->projecttypeTasktypes as $pttt)
        {
            array_push($arr, $pttt->tasktype);
        }
        return $arr;
    }

    public function getTasktypesIDs()
    {
        $arr = array();
        foreach ($this->projecttypeTasktypes as $pttt)
        {
            array_push($arr, $pttt->tasktype->id);
        }
        return $arr;
    }

    /**  @Id @Column(type="integer") @GeneratedValue */
    protected $id;

    /**
     * @Column(type="string")
     */
    public $name;

    /**
     * @Column(type="string")
     */
    public $company;

    //получить таски по типу проекта
    public static function GrabTasktypesByProjectType($project_type_id, $manager=null)
    {
        global $companyID, $entityManager;
        if ( null == $entityManager ) {
            $entityManager = $manager;
        }
        if (!isset($project_type_id))
            $ptypes = $entityManager->getRepository('ProjectType')->findBy(array('company' => $companyID));
        else
        {
            /** @var ProjectType $pt */
            $pt = $entityManager->find('ProjectType',$project_type_id);
            $ptypes = array($pt);
        }
        $tasktypes = array();

        foreach ($ptypes as $pt) {
            
            $tasktypes = $pt->getTasktypes();
            foreach ($tasktypes as $tt) {
                if ($tt == null) {
                    continue;
                }
            }
        }
        return $tasktypes;
    }

//    public function deleteTasktype($key)
//    {
//        return $this->tasktypes->removeElement($key);
//    }
//
//    public function getTasktypes()
//    {
//        return $this->tasktypes;
//    }
//
//    public function addTasktype($tasktype, $priority)
//    {
//        return $this->tasktypes[] = $tasktype;
//    }


//
//    public function addProject(Project $projectslocotech): self
//    {
//        if (!$this->projects->contains($projectslocotech)) {
//            $this->projects[] = $projectslocotech;
//            $projectslocotech->setActions($this);
//        }
//
//        return $this;
//    }
//
//    public function removeProject(Project $projectslocotech): self
//    {
//        if ($this->projects->contains($projectslocotech)) {
//            $this->projects->removeElement($projectslocotech);
//            // set the owning side to null (unless already changed)
//            if ($projectslocotech->getActions() === $this) {
//                $projectslocotech->setActions(null);
//            }
//        }
//
//        return $this;
//    }


}

