<?php

//namespace Tasks;
/**
 * @Entity @Table(name="tasks")
 */
class Task extends BaseDBO
{
//    public function __construct()
//    {
//        $this->accepted_time = new DateTime();
//    }
//todo add tasktypes
    /**
     * @var Account
     * @ManyToOne(targetEntity="Account", inversedBy="tasks")
     * @JoinColumn(name="assignees_arr", referencedColumnName="id")
     */
    public $account;

    public function getAccount()
    {
//        try {
//            $this->account->__load();
//        } catch (\Doctrine\ORM\EntityNotFoundException $e) {
//            $this->account = null;
//        }
        return $this->account;
    }

    public function getSection():Section
    {
        if ($this->parent_id > 0)
        {
            $parent = Task::Find($this->parent_id);
            if ($parent != null)
            {
                return $parent->getSection();
            }
        }
        else {
            $project = $this->project;
            if ($project != null) {
                $loconum = $project->loco_number;
                $series = $project->getLocoType();
                $tt = Tasktype::Find($this->type);
                if ($tt != null) {
                    $letter = $tt->letter;
                    $sections = Section::FindByLetter($series, $loconum, $letter);
                    $size = sizeof($sections);
//                    echo "secs $size";
                    if ($size > 0)
                        return $sections[0];
                }
            }
        }
        return null;
    }

    /**
     * One task has many tasknotes. This is the inverse side.
     * @OneToMany(targetEntity="Tasknote", mappedBy="task")
     */
    private $tasknotes;
    /**
     * @var Project
     * Many tasks have one project. This is the owning side.
     * @ManyToOne(targetEntity="Project", inversedBy="tasks")
     * @JoinColumn(name="input_id", referencedColumnName="id")
     */
    public $project;

    /** @Id @Column(type="integer") @GeneratedValue */
    protected $id;

    /**     @Column(type="integer")     */
    public $type;

    /**     @Column(type="integer")     */
    public $input_id;

    /**     @Column(type="integer")     */
    public $asusg_job_mapped_id;

    /** @Column(type="smallint")     */
    public $priority;

    /**     @Column(type="integer")     */
    public $parent_id;

    /** @Column(type="smallint")     */
    public $status;

    /** @Column(type="datetime")     */
    public $created;

    /** @Column(type="datetime")     */
    public $assigned;

    /** @Column(type="datetime")     */
    public $accepted_time;

    /** @Column(type="datetime")     */
    public $finished_time;

    /** @Column(type="datetime")     */
    public $expires;

    /** @Column(type="string")     */
    public $text;

    /** @Column(type="string")     */
    public $name;

    /** @Column(type="smallint")     */
    public $control_map_checked;

    /** @Column(type="string")     */
    public $confirm_data;

    /** @Column(type="integer")     */
    public $assignees_arr;

    /** @Column(type="integer")     */
    public $zone_id;

    /** @Column(type="integer")     */
    public $object_id;

    /**
     * @Column(type="integer")
     */
    public $preferred_assignee;

    /** @Column(type="string")     */
    public $asusg_task_hw_measurement_id;

    //todo проверить меняется ли статус у проекта при удалении задач
    public function ClearAssignee(bool $save = true)
    {
        $this->status = 1;
        EnqueueCMD($this->account->id, 21);
        $this->account->tasks->removeElement($this);
        $this->account = null;
        $this->assignees_arr = 0;
        if ($save)
            $this->Save();
    }

    public function AddRemark($text)
    {

        //TODO заменить настройкой исключения записи замечаний
        if (intval($this->type) == 741 || intval($this->type) == 743)
        {
            return;
        }
        $section = $this->getSection();
        $account = $this->account;
        /**
         *  @var $section Section
         *
         */
        if ($section != null && $account != null)
        {
            return $section->AddRemark($account, $text);
        }
        return null;
    }

    public function addAssignee($account, bool $save = true)
    {
        $this->status = 2;
        $this->account->tasks[] = $account;
        if ($save)
            $this->Save();
    }

//    private $name;
//    private $childrenTasks;
}