<?php /** Created by Anton on 06.03.2020. */

namespace classes;

use PDOException;

class PDO
{
    /** @var \PDO */
    protected static $pdo = null;

    protected $pdo_options = [
        \PDO::ATTR_ERRMODE => \PDO::ERRMODE_EXCEPTION,
        \PDO::ATTR_DEFAULT_FETCH_MODE => \PDO::FETCH_ASSOC,
        \PDO::ATTR_EMULATE_PREPARES => false,
    ];

    protected function __construct()
    {
        /** @var string $db_hostname */
        /** @var string $db_name */
        /** @var string $db_username */
        /** @var string $db_password */
        require dirname(dirname(__DIR__)) . '/config.php';

        try {
            self::$pdo = new \PDO('mysql:host=' . $db_hostname . ';dbname=' . $db_name, $db_username, $db_password, $this->pdo_options);
        } catch (PDOException $e) {
            die('Подключение не удалось: ' . $e->getMessage());
        }
    }

    /** @return \PDO */
    public static function getInsatance()
    {
        if (!self::$pdo) {
            new self();
        }

        return self::$pdo;
    }
}
