<?php /** Created by Anton on 11.02.2020. */
/** @var string $act */
$query = new \yii\db\Query();
$query->select('t.id, t.title, t.write_off_date, tlog.note')
    ->from(\app\models\entity\Tmc::tableName() . ' t')
    ->leftJoin(\app\models\entity\Log::tableName() . ' tlog', 'tlog.tmc = t.id')
    ->where('t.status = ' . \app\models\entity\TmcStatus::TMC_STATUS_DECOMMISSION)
;
$devices = $query->all();
?>
<link href="/tmc/css/main.min.css" rel="stylesheet">
<style type="text/css">
    .main_content {
        padding: 0;
        display: inline-flex;
    }
</style>

<div class="menuTask loco-scrol-blue scroller">
    <div class="menuTaskHeader">Список списанных устройств</div>
    <div class="boxB4">
        <div class="inpBox">
            <input class="js-search" type="text" placeholder="Поиск">
            <img src="/images/find.svg">
        </div>
    </div>
    <div class="boxB5">
        <div class="tmc-content">
            <?php foreach ($devices as $device): ?>
                <a href="?act=tmc/detail/added&id=<?= $device['id'] ?>" class="loco_list">
                    <div>
                        <h5><?= $device['title'] ?></h5>
                        <p>
                            <t class="loco_grey"><?= $device['write_off_date'] ?></t>
                        </p>
                        <p>
                            <t class="loco_grey"><?= $device['note'] ?></t>
                        </p>
                    </div>
                </a>
            <?php endforeach; ?>
        </div>
    </div>
</div>
<?php if ($act == 'tmc/write') {
    require (dirname(__DIR__) . '/tmc/forms/write-off.php');
}?>
<div role="log" aria-live="assertive" aria-relevant="additions" class="ui-helper-hidden-accessible"></div>
<script type="application/javascript" src="tmc/js/search.js"></script>